#ifndef _WIN32
	#include "tap.h"
	#define GRDEBUG					0

	#include "_displib_/gr_inc.h"
	#include "topfield_hw.c"

	#define ID_DIRECTOSD 0x80000105
	TAP_ID( ID_DIRECTOSD );
	TAP_PROGRAM_NAME("DISPTEST");
	TAP_AUTHOR_NAME("ROLANDAIGNER");
	TAP_DESCRIPTION("DISPLIB Test");
TAP_ETCINFO(__DATE__);


#endif





word *_vAddr[576];
static word rgn;
char _strBuf[40];


typeImage *LoadImage(char *name, BOOL transparent)
{
	TYPE_File *_bmpFile;
	unsigned char a, b;
	int x, y, xl, yl, blockloop;
	typeImage *image = NULL;
	long c;
	int r, g, cb;
	char *block;

#if GRDEBUG
	rgn = TAP_Osd_Create( 0, 0, 720, 576, 0, FALSE );
#endif

	_bmpFile = TAP_Hdd_Fopen(name);
	TAP_Hdd_Fread(&a, 1, 1, _bmpFile);
	TAP_Hdd_Fread(&b, 1, 1, _bmpFile);
	x = a; x = x << 8; x = x | b;

#if GRDEBUG
	TAP_SPrint(_strBuf, "x = %d, %d, %d\r\n", x, a, b);
	TAP_Osd_PutStringAf1926( rgn, 100, 100, 600, _strBuf, COLOR_DarkCyan, COLOR_Black);
#endif

	TAP_Hdd_Fread(&a, 1, 1, _bmpFile);
	TAP_Hdd_Fread(&b, 1, 1, _bmpFile);
	y = a; y = y << 8; y = y | b;

#if GRDEBUG
	TAP_SPrint(_strBuf, "y = %d\r\n", y);
	TAP_Osd_PutStringAf1926( rgn, 100, 200, 600, _strBuf, COLOR_DarkCyan, COLOR_Black);
#endif

	block = (char *)malloc(x * 3 + 20);

	image = grCreateImage(x, y, RGB(0, 0, 0));
	for (yl = 0; yl < y; yl++) {
		TAP_Hdd_Fread(block, x * 3, 1, _bmpFile);
		blockloop = 0;
		for (xl = 0; xl < x; xl++) {
			c = 0;
			a = block[blockloop++]; r = a&0xFF;
			a = block[blockloop++]; g = a&0xFF;
			a = block[blockloop++]; cb = a&0xFF;

#ifndef _WIN32
			r = r >> 3; g = g >> 3; cb = cb >> 3;
#endif

			if (transparent == FALSE) {
				grSetPixelOnImage(image, xl, yl, RGB(r, g, cb));
			} else {
				if ((r==0) && (g == 0) && (cb == 0)) {
					grSetPixelOnImage(image, xl, yl, ARGB(0, r, g, cb));
				} else {
					grSetPixelOnImage(image, xl, yl, ARGB(1, r, g, cb));
				}
			}

#if GRDEBUG
			if (xl < 700) {
				grSetPixel(xl, yl + 30, c);
			}
#endif

		}
	}

	TAP_Hdd_Fclose(_bmpFile);

	free(block);

#if GRDEBUG
	TAP_Delay(200);
	TAP_Osd_Delete(rgn);
#endif

	return image;
}


typeFont *LoadFont(char *name, BOOL transparent)
{
	typeFont *font = NULL;
	typeImage *image = LoadImage(name, transparent);


	if (image != NULL) {
		font = fntConvertImage2Font(image, "0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz!?.:-+*/<>$()=^@");
		grDeleteImage(image);
	}
	return font;
}





int _topflastkey = 0;
bool _exitFlag = FALSE;

dword TAP_EventHandler( word event, dword param1, dword param2 )
{
    if( event == EVT_KEY )
    {
        if (param1 == RKEY_Exit) {
			_exitFlag = TRUE;
        }

		_topflastkey = param1;
	    return 0;
    }
    return param1;
}


#define XDESC	(720 - menuhead->xsize)/2
#define YDESC	ys + back->ysize
void MenuTest()
{
	typeImage *back;
	typeFont *fntlo, *fnthi, *headerfnt;
	typeMenu *menu;
	char keytext[40];
	int menukey = 0;
	int key;
	int xs, ys;
	typeImage *clocklo, *clockhi, *bookhi, *booklo, *edithi, *editlo, *worldhi, *worldlo, *menuhead, *backblack;
	int idnew, idfirst, idback;

	menu = menuCreateMenu("DemoMenu");

	back = LoadImage("menuback.img", FALSE);
	fntlo = LoadFont("fntlo.fnt", FALSE); fntSetFontTransparency(fntlo, TRUE, RGB(0, 0, 0));
	fnthi = LoadFont("fnthi.fnt", FALSE); fntSetFontTransparency(fnthi, TRUE, RGB(0, 0, 0));
	headerfnt = LoadFont("bigfont.fnt", FALSE); fntSetFontTransparency(headerfnt, TRUE, RGB(0, 0, 0));

	clocklo = LoadImage("clocklo.img", FALSE); grSetImageTransparency(clocklo, TRUE, RGB(0, 0, 0));
	clockhi = LoadImage("clockhi.img", FALSE); grSetImageTransparency(clockhi, TRUE, RGB(0, 0, 0));
	booklo = LoadImage("booklo.img", FALSE); grSetImageTransparency(booklo, TRUE, RGB(0, 0, 0));
	bookhi = LoadImage("bookhi.img", FALSE); grSetImageTransparency(bookhi, TRUE, RGB(0, 0, 0));
	editlo = LoadImage("editlo.img", FALSE); grSetImageTransparency(editlo, TRUE, RGB(0, 0, 0));
	edithi = LoadImage("edithi.img", FALSE); grSetImageTransparency(edithi, TRUE, RGB(0, 0, 0));
	worldlo = LoadImage("worldlo.img", FALSE); grSetImageTransparency(worldlo, TRUE, RGB(0, 0, 0));
	worldhi = LoadImage("worldhi.img", FALSE); grSetImageTransparency(worldhi, TRUE, RGB(0, 0, 0));

	backblack = grCreateImage(240, 40, RGB(20, 20, 120));

	menuhead = LoadImage("menuhead.img", FALSE);

	xs = (720 - back->xsize)/2;
	ys = (576 - back->ysize)/2;

	//idback=menuAddItem(menu, "background", xs, ys, 0, MENU_TRIGGER_FIX, MENU_ENTRY_IMAGE, back, NULL, NULL);
	//menuAddItem(menu, "header", (720 - menuhead->xsize)/2, ys-80, 0, MENU_TRIGGER_FIX, MENU_ENTRY_IMAGE, menuhead, NULL, NULL);
	grPutImage(xs, ys, back);
	grPutImage((720 - menuhead->xsize)/2, ys-80, menuhead);

	menuAddItem(menu, "header", (720 - menuhead->xsize)/2, ys + back->ysize, 0, MENU_TRIGGER_FIX, MENU_ENTRY_IMAGE, backblack, NULL, NULL);


	/*
	for (int loop = 0; loop < 5; loop++) {
		sprintf(keytext, "menu item %d", loop);
		idnew=menuAddItem(menu, keytext, 80, loop*20+20, 1, MENU_TRIGGER_COLD, MENU_ENTRY_TEXT, fntlo, keytext, NULL);
		if (loop == 0) idfirst = idnew;
		menuAddItem(menu, keytext, 80, loop*20+20, 1, MENU_TRIGGER_HOT, MENU_ENTRY_TEXT, fnthi, keytext, NULL);
		menuSetKeyPath(menu, idnew, idnew-1, idnew+1, -1, -1);
	}
	*/


	idfirst = idnew = menuAddItem(menu, "1", xs + 150, ys + 50, 1, MENU_TRIGGER_COLD, MENU_ENTRY_IMAGE, clocklo, NULL, NULL);
	menuAddItem(menu, "1", xs + 150, ys + 50, 1, MENU_TRIGGER_HOT, MENU_ENTRY_IMAGE, clockhi, NULL, NULL);
	menuAddItem(menu, "1", XDESC, YDESC, 2, MENU_TRIGGER_HOT, MENU_ENTRY_TEXT, headerfnt, "ClockIcon", NULL);
	menuSetKeyPath(menu, idnew, idnew-1, idnew+1, -1, -1);

	idnew = menuAddItem(menu, "2", xs + 200, ys + 100, 1, MENU_TRIGGER_COLD, MENU_ENTRY_IMAGE, worldlo, NULL, NULL);
	menuAddItem(menu, "2", xs + 200, ys + 100, 1, MENU_TRIGGER_HOT, MENU_ENTRY_IMAGE, worldhi, NULL, NULL);
	menuAddItem(menu, "2", XDESC, YDESC, 2, MENU_TRIGGER_HOT, MENU_ENTRY_TEXT, headerfnt, "WorldIcon", NULL);
	menuSetKeyPath(menu, idnew, idnew-1, idnew+1, -1, -1);

	idnew = menuAddItem(menu, "3", xs + 230, ys + 160, 1, MENU_TRIGGER_COLD, MENU_ENTRY_IMAGE, booklo, NULL, NULL);
	menuAddItem(menu, "3", xs + 230, ys + 160, 1, MENU_TRIGGER_HOT, MENU_ENTRY_IMAGE, bookhi, NULL, NULL);
	menuAddItem(menu, "3", XDESC, YDESC, 2, MENU_TRIGGER_HOT, MENU_ENTRY_TEXT, headerfnt, "BookIcon", NULL);
	menuSetKeyPath(menu, idnew, idnew-1, idnew+1, -1, -1);

	idnew = menuAddItem(menu, "4", xs + 180, ys + 210, 1, MENU_TRIGGER_COLD, MENU_ENTRY_IMAGE, editlo, NULL, NULL);
	menuAddItem(menu, "4", xs + 180, ys + 210, 1, MENU_TRIGGER_HOT, MENU_ENTRY_IMAGE, edithi, NULL, NULL);
	menuAddItem(menu, "4", XDESC, YDESC, 2, MENU_TRIGGER_HOT, MENU_ENTRY_TEXT, headerfnt, "EditIcon", NULL);
	menuSetKeyPath(menu, idnew, idnew-1, idnew+1, -1, -1);


	menuSetKeyPath(menu, idnew, idnew-1, idfirst, -1, -1); // last in menu
	menuSetKeyPath(menu, idfirst, idnew, idfirst+1, -1, -1);

	menukey = MENU_KEY_NO;
	menuDoMenu(menu, 0, 0, menukey, NULL);
	grUpdate();


	// main program loop
	while ((key != RKEY_Ok) && (key != RKEY_Exit)) {
		int trigger;
		key = _topflastkey; _topflastkey = 0;

		if (key != 0) {
			sprintf(keytext, "0x%04X", key);
		}

		menukey = MENU_KEY_NO;
		if (key == RKEY_ChUp) menukey = MENU_KEY_UP;
		if (key == RKEY_ChDown) menukey = MENU_KEY_DOWN;
		if (key == RKEY_VolDown) menukey = MENU_KEY_LEFT;
		if (key == RKEY_VolUp) menukey = MENU_KEY_RIGHT;

		if (key!=0) {
			menuDoMenu(menu, 0, 0, menukey, NULL);
			grUpdate();
		}
		TAP_SystemProc();
	}
}


int TAP_Main(void)
{
    dword i;
    dword x, y, t, oldx, oldy, xx, xi, yi;
	dword pos = 0;
	typeImage *image = NULL, *background = NULL;
	COLORTYPE backcol;
	typeFont *font = NULL;
	typeImage *rock = NULL;
	typeImage *conan = NULL;
	typeMenu *menu;


	TAP_ExitNormal();

	grOpen(720, 576);

	font = LoadFont("font.fnt", FALSE);
	rock = LoadImage("rockhouse.img", FALSE);
	conan = LoadImage("conan.img", TRUE);


	MenuTest();

	backcol = grGetPixel(10, 10);
	image = grCreateImage(20, 20, RGB(100, 0, 0));
	background = grCreateImage(20, 20, backcol);

	for (x = 0; x < 20; x++) {
		for (y = 0; y < 20; y++) {
			grSetPixelOnImage(image, x, y, rand()*rand()*rand()*rand());
			grSetPixelOnImage(background, x, y, backcol);
		}
	}

	oldx = pos; oldy = pos;

	if (font != NULL) {
		ttyInit(font);
	}

	xx = 620;

	if (rock != NULL) {
		grPutImage(100, 300, rock);
	}


	xi = 300; yi = 220;
	_topflastkey = 0;

    while(_exitFlag == FALSE) {
        // draw
#if 0
        for( y=0; y<576; y++ ) {
            for( x=0; x<720; x++ ) {
                grSetPixel(x, y, RGB((t+y)*0x1f/576, (t+x)*0x1f/720, (t+y+x)*0x1f/(720+576)));
            }
        }
        t+=2;
#endif

		if (_topflastkey != 0) {
			switch (_topflastkey) {
				case RKEY_VolDown: if (xi > 0) xi--; break;
				case RKEY_VolUp: if (xi < (720 - image->xsize)) xi++; break;
				case RKEY_ChDown: if (yi < (576 - image->ysize)) yi++; break;
				case RKEY_ChUp: if (yi > 0) yi--; break;
			}
			_topflastkey = 0;
		}

		grPutImage(oldx, oldy, background);
		pos += 1;
		grPutImage(xi, yi, image);
		oldx = pos; oldy = pos;

		if (pos > 250) {
			pos = 0;
		}

		if (font != NULL) {
			//fntDrawString(font, 200, 200, "Roland");
			//TAP_SPrint(_strBuf, "%c", (rand()+31)%100);
			//ttyPrint(_strBuf);
			TAP_SPrint(_strBuf, "%d", xx);
			fntDrawString(font, 200, 100, _strBuf);

		}


		if (conan != NULL) {
			grPutImage(xx--, 200, conan);
			if (xx == 0) xx = 620;
		}


		grUpdate();
        TAP_SystemProc();
	}
	TAP_EnterNormal();

	if (font != NULL) fntFreeFontMemory(font);
	if (image != NULL) grDeleteImage(image);
	if (background != NULL) grDeleteImage(background);
	if (rock != NULL) grDeleteImage(rock);
	if (conan != NULL) grDeleteImage(conan);

	grClearScreen(ARGB(0, 0, 0, 0));

    return 0;
}


